"use strict" ;

/**
 * Transform a rgb component in this hexadecimal expression.
 * @name rgbToHex
 * @memberof core.colors
 * @function
 * @instance
 * @param {number} r - The red component value.
 * @param {number} g - The green component value.
 * @param {number} b - The blue component value.
 * @example
 * console.log( rgbToHex( 0xFF , 0    , 0    ) ) ; // #ff0000
 * console.log( rgbToHex( 0    , 0xFF , 0    ) ) ; // #00ff00
 * console.log( rgbToHex( 0    , 0    , 0xFF ) ) ; // #0000ff
 */
const rgbToHex = ( r , g , b ) => '#' + [r, g, b].map( x => Number(x).toString(16).padStart(2, '0') ).join('') ;

export default rgbToHex ;