"use strict" ;

import baseGet        from './objects/baseGet'
import castPath       from './objects/castPath'
import clean          from './objects/clean'
import forEach        from './objects/forEach'
import fuse           from './objects/fuse'
import get            from './objects/get'
import getTag         from './objects/getTag'
import isEmpty        from './objects/isEmpty'
import isKey          from './objects/isKey'
import members        from './objects/members'
import merge          from './objects/merge'
import pick           from './objects/pick'
import removeProperty from './objects/removeProperty'
import renameProperty from './objects/renameProperty'
import set            from './objects/set'
import toKey          from './objects/toKey'

/**
 * The {@link core.objects} package is a modular <b>JavaScript</b> library that provides extra <code>Object</code> methods and implementations.
 * @summary The {@link core.objects} package is a modular <b>JavaScript</b> library that provides extra <code>Object</code> methods and implementations.
 * @license {@link https://www.mozilla.org/en-US/MPL/2.0/|MPL 2.0} / {@link https://www.gnu.org/licenses/old-licenses/gpl-2.0.fr.html|GPL 2.0} / {@link https://www.gnu.org/licenses/old-licenses/lgpl-2.1.fr.html|LGPL 2.1}
 * @author Marc Alcaraz <ekameleon@gmail.com>
 * @namespace core.objects
 * @memberof core
 */
const objects =
{
    baseGet,
    castPath,
    clean,
    forEach,
    fuse,
    get,
    getTag,
    isEmpty,
    isKey,
    members,
    merge,
    pick,
    removeProperty,
    renameProperty,
    set,
    toKey
} ;

export default objects ;