"use strict" ;

/**
 * Indicates if the object is empty and not contains enumerable properties.
 * @version 1.0.25
 * @since 1.0.25
 * @name isEmpty
 * @memberof core.objects
 * @function
 * @instance
 * @param {Object} object - The object to evaluate.
 * @return {Boolean} True if the object is empty
 * @example
 * console.log( isEmpty( {} ) ) ; // true
 * console.log( isEmpty( { name: 'John Doe' } ) ) ; // false
 */
const isEmpty = object => Object.keys( object ).length === 0;

export default isEmpty ;